/*K܂Ă܂*/

#include <stdio.h.>


class miko2img{
private:
  unsigned char bitmapFileHeader[14];
  unsigned char bitmapInfoHeader[40];
  unsigned char bitmapImagePixel[921602];
public:
  read(char *fn){
    FILE *fp;
    fp=fopen(fn, "rb");
    if(fp==NULL){fprintf(stderr, "src file open err.\n");exit(0);}
    fread(bitmapFileHeader,     14, 1, fp);
    fread(bitmapInfoHeader,     40, 1, fp);
    fread(bitmapImagePixel, 921602, 1, fp);
    fclose(fp);
  }
  unsigned long calc_y(unsigned long x, unsigned long y){
    unsigned long addr, b,g,r,yv;
    addr = (307199-(x+y*640))*3;
    b=bitmapImagePixel[addr];
    g=bitmapImagePixel[addr+1];
    r=bitmapImagePixel[addr+2];
    yv=30*r+59*g+11*b;//MIN=0,MAX=25500
    return yv;
  }
};


class palmimg{
private:
  unsigned char bitmapFileHeader[14];
  unsigned char bitmapInfoHeader[40];
  unsigned char bitmapPalette[64];//16*4
  unsigned char bitmapImagePixel[9600];
  miko2img m2img;
public:
  palmimg(){
    const unsigned char fileheader[14]=
    {0x42,0x4d,
     0xf6,0x25,0x00,0x00,
     0x00,0x00,
     0x00,0x00,
     0x76,0x00,0x00,0x00};
    const unsigned char infoheader[40]=
    {0x28,0x00,0x00,0x00,
     0xa0,0x00,0x00,0x00,
     0x78,0x00,0x00,0x00,
     0x01,0x00,
     0x04,0x00,
     0x00,0x00,0x00,0x00,
     0x00,0x00,0x00,0x00,
     0x04,0xec,0x00,0x00,
     0x04,0xec,0x00,0x00, 
     0x10,0x00,0x00,0x00,
     0x10,0x00,0x00,0x00};
     const unsigned char palette[64]=
    {0x00,0x00,0x00,0x00,
     0x11,0x11,0x11,0x00,
     0x22,0x22,0x22,0x00,
     0x33,0x33,0x33,0x00,
     0x44,0x44,0x44,0x00,
     0x55,0x55,0x55,0x00,
     0x66,0x66,0x66,0x00,
     0x77,0x77,0x77,0x00,
     0x88,0x88,0x88,0x00,
     0x99,0x99,0x99,0x00,
     0xaa,0xaa,0xaa,0x00,
     0xbb,0xbb,0xbb,0x00,
     0xcc,0xcc,0xcc,0x00,
     0xdd,0xdd,0xdd,0x00,
     0xee,0xee,0xee,0x00,
     0xff,0xff,0xff,0x00};
    memcpy(bitmapFileHeader, fileheader, 14);
    memcpy(bitmapInfoHeader, infoheader, 40);
    memcpy(bitmapPalette   , palette   , 64);
  }
  void read(char *filename){
    m2img.read(filename);
    for(int n=0;n<9600;n++){
      bitmapImagePixel[n]=n%0xff;
    }
  int p=0;
  for(int y=476;y>=0;y-=4){
    for(int x=632;x>=0;x-=8){
      unsigned long yv[16]; long avr; unsigned char idx;

      yv[0]=m2img.calc_y(x,y);
      yv[1]=m2img.calc_y(x,y+1);
      yv[2]=m2img.calc_y(x+1,y);
      yv[3]=m2img.calc_y(x+1,y+1);

      yv[4]=m2img.calc_y(x+2,y);
      yv[5]=m2img.calc_y(x+2,y+1);
      yv[6]=m2img.calc_y(x+3,y);
      yv[7]=m2img.calc_y(x+3,y+1);

      yv[8]=m2img.calc_y(x,y+2);
      yv[9]=m2img.calc_y(x,y+3);
      yv[10]=m2img.calc_y(x+1,y+2);
      yv[11]=m2img.calc_y(x+1,y+3);

      yv[12]=m2img.calc_y(x+2,y+2);
      yv[13]=m2img.calc_y(x+2,y+3);
      yv[14]=m2img.calc_y(x+3,y+2);
      yv[15]=m2img.calc_y(x+3,y+3);
      avr = (yv[0]+yv[1]+yv[2]+yv[3]+yv[4]+yv[5]+yv[6]+yv[7]
            +yv[8]+yv[9]+yv[10]+yv[11]+yv[12]+yv[13]+yv[14]+yv[15]
)/16; //AVR
      idx = avr * 16 / 25501;            //INDEX
      bitmapImagePixel[p]=idx;

      yv[0]=m2img.calc_y(x+4,y);
      yv[1]=m2img.calc_y(x+4,y+1);
      yv[2]=m2img.calc_y(x+5,y);
      yv[3]=m2img.calc_y(x+5,y+1);

      yv[4]=m2img.calc_y(x+6,y);
      yv[5]=m2img.calc_y(x+6,y+1);
      yv[6]=m2img.calc_y(x+7,y);
      yv[7]=m2img.calc_y(x+7,y+1);

      yv[8]=m2img.calc_y(x+4,y+2);
      yv[9]=m2img.calc_y(x+4,y+3);
      yv[10]=m2img.calc_y(x+5,y+2);
      yv[11]=m2img.calc_y(x+5,y+3);

      yv[12]=m2img.calc_y(x+6,y+2);
      yv[13]=m2img.calc_y(x+6,y+3);
      yv[14]=m2img.calc_y(x+7,y+2);
      yv[15]=m2img.calc_y(x+7,y+3);
      avr = (yv[0]+yv[1]+yv[2]+yv[3]+yv[4]+yv[5]+yv[6]+yv[7]
            +yv[8]+yv[9]+yv[10]+yv[11]+yv[12]+yv[13]+yv[14]+yv[15]
)/16; //AVR
      idx = avr * 16 / 25501;            //INDEX
      bitmapImagePixel[p++]|=(idx<<4);

    }
  }

  }
  void write(char *filename){
    FILE *fp;
    fp=fopen(filename, "wb");
    if(fp==NULL){fprintf(stderr, "dst file open err.\n");exit(0);}
    fwrite(bitmapFileHeader,  14, 1, fp);
    fwrite(bitmapInfoHeader,  40, 1, fp);
    fwrite(bitmapPalette,     64, 1, fp);
    fwrite(bitmapImagePixel,9600, 1, fp);
    fclose(fp);
  }

};



int main(int argc, char *argv[])
{
  palmimg pimg;
  pimg.read(argv[1]);
  pimg.write(argv[2]);
  return 0;
}

