#include <stdio.h>

class ico{
private:
  int cd[16];
  int pixelcd[32][32];
public:
  void read(char *filename){
    FILE *fp;
    unsigned char tmp[0x200];//512
    int n,x,y;
    fp=fopen(filename, "rb");
    if(fp==NULL){fprintf(stderr, "src file open err.\n");exit(0);}
    fread(tmp, 0x3e, 1, fp);
    for(n=0;n<16;n++){
      fread(tmp, 0x04, 1, fp);//BGRx
      cd[n]=30*tmp[2]+59*tmp[1]+11*tmp[0];//from 0 to 25500
    }
    fread(tmp, 0x200, 1, fp);
    n=0;
    for(y=0;y<32;y++){
      for(x=0;x<32;x+=2){
        pixelcd[x  ][y]=cd[(((tmp[n])&(unsigned char)0xf0)>>4)];
        pixelcd[x+1][y]=cd[(((tmp[n])&(unsigned char)0x0f)   )];
        n++;
      }
    }
    fclose(fp);
  }
  void write_4bpp(char *filename){
    const unsigned char fileheader[14]=
    {0x42,0x4d,
     0x76,0x02,0x00,0x00,
     0x00,0x00,
     0x00,0x00,
     0x76,0x00,0x00,0x00};
    const unsigned char infoheader[40]=
    {0x28,0x00,0x00,0x00,
     0x20,0x00,0x00,0x00,
     0x20,0x00,0x00,0x00,
     0x01,0x00,
     0x04,0x00,
     0x00,0x00,0x00,0x00,
     0x00,0x00,0x00,0x00,
     0x04,0xec,0x00,0x00,
     0x04,0xec,0x00,0x00, 
     0x10,0x00,0x00,0x00,
     0x10,0x00,0x00,0x00};
     const unsigned char palette[64]=
    {0x00,0x00,0x00,0x00,
     0x11,0x11,0x11,0x00,
     0x22,0x22,0x22,0x00,
     0x33,0x33,0x33,0x00,
     0x44,0x44,0x44,0x00,
     0x55,0x55,0x55,0x00,
     0x66,0x66,0x66,0x00,
     0x77,0x77,0x77,0x00,
     0x88,0x88,0x88,0x00,
     0x99,0x99,0x99,0x00,
     0xaa,0xaa,0xaa,0x00,
     0xbb,0xbb,0xbb,0x00,
     0xcc,0xcc,0xcc,0x00,
     0xdd,0xdd,0xdd,0x00,
     0xee,0xee,0xee,0x00,
     0xff,0xff,0xff,0x00};

    FILE *fp;
    fp=fopen(filename, "wb");
    if(fp==NULL){fprintf(stderr, "dst file open err.\n");exit(0);}
    fwrite(fileheader,  14, 1, fp);
    fwrite(infoheader,  40, 1, fp);
    fwrite(palette,     64, 1, fp);

    int x,y;
    for(y=0;y<32;y++){
      for(x=0;x<32;x+=2){
        unsigned char c;
        c =(pixelcd[x  ][y]*16/25501)<<4;
        c|=(pixelcd[x+1][y]*16/25501);
        fwrite(&c, 1, 1, fp);
      }
    }
    fclose(fp);
  }
  void write_1bpp(char *filename){
    const unsigned char fileheader[14]=
    {0x42,0x4d,
     0xbe,0x00,0x00,0x00,
     0x00,0x00,
     0x00,0x00,
     0x3e,0x00,0x00,0x00};
    const unsigned char infoheader[40]=
    {0x28,0x00,0x00,0x00,
     0x20,0x00,0x00,0x00,
     0x20,0x00,0x00,0x00,
     0x01,0x00,
     0x01,0x00,
     0x00,0x00,0x00,0x00,
     0x00,0x00,0x00,0x00,
     0x04,0xec,0x00,0x00,
     0x04,0xec,0x00,0x00, 
     0x02,0x00,0x00,0x00,
     0x02,0x00,0x00,0x00};
     const unsigned char palette[8]=
    {0x00,0x00,0x00,0x00,
     0xff,0xff,0xff,0x00};

    FILE *fp;
    fp=fopen(filename, "wb");
    if(fp==NULL){fprintf(stderr, "dst file open err.\n");exit(0);}
    fwrite(fileheader,  14, 1, fp);
    fwrite(infoheader,  40, 1, fp);
    fwrite(palette,      8, 1, fp);

    int x,y;
    for(y=0;y<32;y++){
      for(x=0;x<32;x+=8){
        unsigned char c;
        c =((pixelcd[x  ][y]*16/25501)>=5?0x80:0x00);
        c|=((pixelcd[x+1][y]*16/25501)>=5?0x40:0x00);
        c|=((pixelcd[x+2][y]*16/25501)>=5?0x20:0x00);
        c|=((pixelcd[x+3][y]*16/25501)>=5?0x10:0x00);
        c|=((pixelcd[x+4][y]*16/25501)>=5?0x08:0x00);
        c|=((pixelcd[x+5][y]*16/25501)>=5?0x04:0x00);
        c|=((pixelcd[x+6][y]*16/25501)>=5?0x02:0x00);
        c|=((pixelcd[x+7][y]*16/25501)>=5?0x01:0x00);
        fwrite(&c, 1, 1, fp);
      }
    }
    fclose(fp);
  }
  void write_1bpp_dither(char *filename){
    const unsigned char fileheader[14]=
    {0x42,0x4d,
     0xbe,0x00,0x00,0x00,
     0x00,0x00,
     0x00,0x00,
     0x3e,0x00,0x00,0x00};
    const unsigned char infoheader[40]=
    {0x28,0x00,0x00,0x00,
     0x20,0x00,0x00,0x00,
     0x20,0x00,0x00,0x00,
     0x01,0x00,
     0x01,0x00,
     0x00,0x00,0x00,0x00,
     0x00,0x00,0x00,0x00,
     0x04,0xec,0x00,0x00,
     0x04,0xec,0x00,0x00, 
     0x02,0x00,0x00,0x00,
     0x02,0x00,0x00,0x00};
     const unsigned char palette[8]=
    {0x00,0x00,0x00,0x00,
     0xff,0xff,0xff,0x00};

    FILE *fp;
    fp=fopen(filename, "wb");
    if(fp==NULL){fprintf(stderr, "dst file open err.\n");exit(0);}
    fwrite(fileheader,  14, 1, fp);
    fwrite(infoheader,  40, 1, fp);
    fwrite(palette,      8, 1, fp);

    int x,y;
    for(y=0;y<32;y++){
      int value=0;
      for(x=0;x<32;x+=8){
        unsigned char c;
        value+=pixelcd[x  ][y];
        if(value*16/25501>=8){c =0x80;value-=25500;}else{c =0x00;}
        value+=pixelcd[x+1][y];
        if(value*16/25501>=8){c|=0x40;value-=25500;}else{c|=0x00;}
        value+=pixelcd[x+2][y];
        if(value*16/25501>=8){c|=0x20;value-=25500;}else{c|=0x00;}
        value+=pixelcd[x+3][y];
        if(value*16/25501>=8){c|=0x10;value-=25500;}else{c|=0x00;}
        value+=pixelcd[x+4][y];
        if(value*16/25501>=8){c|=0x08;value-=25500;}else{c|=0x00;}
        value+=pixelcd[x+5][y];
        if(value*16/25501>=8){c|=0x04;value-=25500;}else{c|=0x00;}
        value+=pixelcd[x+6][y];
        if(value*16/25501>=8){c|=0x02;value-=25500;}else{c|=0x00;}
        value+=pixelcd[x+7][y];
        if(value*16/25501>=8){c|=0x01;value-=25500;}else{c|=0x00;}
        fwrite(&c, 1, 1, fp);
      }
    }
    fclose(fp);
  }
};

int main(int argc, char *argv[]){
  class ico i;
  i.read(argv[1]);
  i.write_1bpp(argv[2]);
  i.write_4bpp(argv[3]);
  return 0;
}

